diff -bruN freeswan-1.9.orig/pluto/ipsec_doi.c freeswan-1.9/pluto/ipsec_doi.c
--- freeswan-1.9.orig/pluto/ipsec_doi.c	Sun Jan 28 16:03:04 2001
+++ freeswan-1.9/pluto/ipsec_doi.c	Mon Jun 11 16:44:14 2001
@@ -1874,11 +2375,16 @@
     /* SA body in and out */
     RETURN_STF_FAILURE(parse_isakmp_sa_body(&sa_pd->pbs, &sa_pd->payload.sa, &r_sa_pbs
 	    , FALSE, st));
+
     close_message(&md->rbody);
 
     /* save initiator SA for HASH */
     clonereplacechunk(st->st_p1isa, sa_pd->pbs.start, pbs_room(&sa_pd->pbs), "sa in main_inI1_outR1()");
 
+    DBG(DBG_PARSING,
+    DBG_log("finished main_inI1_outR1");
+    );
+
     return STF_REPLY;
 }
 
@@ -1896,21 +2402,37 @@
 main_inR1_outI2(struct msg_digest *md)
 {
     struct state *const st = md->st;
+#ifdef OPENSSL
+  u_int8_t np;
+#endif
+
+  DBG(DBG_PARSING,
+  DBG_log("in main_inR1_outI2");
+  );
 
     /* verify echoed SA */
     {
 	struct payload_digest *const sapd = md->chain[ISAKMP_NEXT_SA];
 
-	RETURN_STF_FAILURE(parse_isakmp_sa_body(&sapd->pbs
-	    , &sapd->payload.sa, NULL, TRUE, st));
+    RETURN_STF_FAILURE(parse_isakmp_sa_body(&sapd->pbs, 
+      &sapd->payload.sa, NULL, TRUE, st));
     }
 
+  /* 
+   * Here, we have to decide if the outgoing packet is going to be created 
+   * for the classic RSASIG, or the OPENSSL functions.
+   */
+#ifdef OPENSSL
+  if (!use_openssl(st->st_connection)) 
+  {
+#endif
     /**************** build output packet HDR;KE;Ni ****************/
 
     /* HDR out.
      * We can't leave this to comm_handle() because the isa_np
      * depends on the type of Auth (eventually).
      */
+
     {
 	struct isakmp_hdr r_hdr = md->hdr;
 
@@ -1920,14 +2442,214 @@
     }
 
     /* KE out */
-    if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group
-    , &md->rbody, ISAKMP_NEXT_NONCE))
+    if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group, 
+      &md->rbody, ISAKMP_NEXT_NONCE))
 	return STF_INTERNAL_ERROR;
 
     /* Ni out */
     if (!build_and_ship_nonce(&st->st_ni, &md->rbody, ISAKMP_NEXT_NONE, "Ni"))
 	return STF_INTERNAL_ERROR;
 
+#ifdef OPENSSL
+  }
+  else /* use_openssl == TRUE */
+  {
+    DBG(DBG_PARSING, 
+    DBG_log("main_inR1_outI2: auth chosen is %s",
+      enum_show(&oakley_auth_names, st->st_oakley.auth));
+    );
+
+    if ((st->st_oakley.auth == OAKLEY_RSA_ENC_REV) ||
+      (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC_REV)) {
+      struct isakmp_hdr r_hdr = md->hdr;
+
+      /* HDR out */
+      r_hdr.isa_np = ISAKMP_NEXT_NONCE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+        return STF_INTERNAL_ERROR;
+      
+      if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+        ISAKMP_NEXT_KE, "<Ni_b>PubKey_r"))
+        return STF_INTERNAL_ERROR;
+
+      if (derive_symmetric_key(st, st->st_ni,
+        st->st_icookie, COOKIE_SIZE,
+        &st->st_ks_i,
+        &st->st_ne_i) < 0) {
+	log("error while deriving symmetric key in revised mode");
+	return STF_INTERNAL_ERROR;
+      }
+      memset(st->st_ne_i_iv, 0, MAX_DIGEST_LEN);
+      DBG(DBG_PARSING,
+      DBG_dump_chunk("Generated Ke_i:", st->st_ne_i);
+      );
+
+      /* KE out */
+      if (!build_and_ship_KE_rpk(st, TRUE, &st->st_gi, st->st_oakley.group,
+        &md->rbody, ISAKMP_NEXT_ID))
+        return STF_INTERNAL_ERROR;
+
+      /* <IDi1_b>Ke_i,[<cert>Ke_i] out */
+      {
+        chunk_t ch, out;
+
+        /*
+         * Switch for different ID types to send
+         */
+	if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+          ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+          ch.ptr = alloc_bytes(ch.len, "encrypted der_asn1_dn identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), 
+            st->st_connection->this.id.der_asn1_dn.ptr, 
+            st->st_connection->this.id.der_asn1_dn.len);
+        } else {
+          ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+          ch.ptr = alloc_bytes(ch.len, "encrypted identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+            sizeof(st->st_connection->this.id.ip_addr));
+	}
+
+        if (!encrypt_payload(st, &st->st_ks_i, st->st_ne_i_iv,
+          ch, &out))
+          return STF_INTERNAL_ERROR;
+        freeanychunk(ch);
+
+        /* Are we going to send CERT? */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) == 0) {
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, &isakmp_generic_desc,
+            &md->rbody, out, "my identity (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        } else {
+          if (!out_generic_chunk(ISAKMP_NEXT_CERT, &isakmp_generic_desc,
+            &md->rbody, out, "my identity (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+
+        /* Well, if we do send CERT, let's start on it from here */
+        if ((st->st_connection->cert_options & CERT_OPTION_SEND) != 0) {
+          chunk_t crt, cx;
+          unsigned long ulen;
+          /* Send the signing certificate */
+
+          ulen = i2d_X509(st->st_connection->cert, NULL);
+          ulen++;
+          if ((cx.ptr = alloc_bytes(ulen, "ASN.1 cert")) == NULL)
+          { 
+            return STF_INTERNAL_ERROR; 
+          }
+          (cx.ptr)[0] = (u_char)(CERT_TYPE_X509_SIG);
+          cx.len = ulen;
+          crt.ptr = &(cx.ptr[1]);
+          crt.len = i2d_X509(st->st_connection->cert, &(crt.ptr));
+
+          DBG(DBG_CRYPT,
+          DBG_log("plaintext Certificate length: %d", cx.len);
+          DBG_dump_chunk("plaintext Certificate", cx);
+          );
+
+          /* encrypt the certificate to send */
+          if (!encrypt_payload(st, &st->st_ks_i, st->st_ne_i_iv,
+            cx, &out))
+          return STF_INTERNAL_ERROR;
+
+          DBG(DBG_CRYPT,
+          DBG_log("cyphertext Certificate length: %d", out.len);
+          DBG_dump_chunk("cyphertext Certificate", out);
+          );
+
+          if (!out_generic_chunk(ISAKMP_NEXT_NONE, 
+            &isakmp_ipsec_certificate_desc,
+            &md->rbody, out, "my certificate (ciphertext)")) 
+          {
+            freeanychunk(out);
+            return STF_INTERNAL_ERROR;
+          }
+        }
+        /* end of sending out cert */
+
+        freeanychunk(out);
+      }
+    } else {
+      struct isakmp_hdr r_hdr = md->hdr;
+      
+      r_hdr.isa_np = ISAKMP_NEXT_KE;
+      if (!out_struct(&r_hdr, &isakmp_hdr_desc, &md->reply, &md->rbody))
+        return STF_INTERNAL_ERROR;
+
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+        (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC))
+        np = ISAKMP_NEXT_ID;
+      else /* Digital Sig or Preshared key */
+        np = ISAKMP_NEXT_NONCE;
+      
+      /* KE out */
+      if (!build_and_ship_KE(st, &st->st_gi, st->st_oakley.group, 
+        &md->rbody, np))
+        return STF_INTERNAL_ERROR;
+      
+      if ((st->st_oakley.auth == OAKLEY_RSA_ENC) ||
+	  (st->st_oakley.auth == OAKLEY_ELGAMAL_ENC)) {
+
+	/* <IDii_b>PubKey_r out */
+	chunk_t ch;
+
+        /* Switch for different ID types to send */
+        if (st->st_connection->this.id.kind == ID_DER_ASN1_DN) {
+          ch.len = st->st_connection->this.id.der_asn1_dn.len + 4;
+          ch.ptr = alloc_bytes(ch.len, "plaintext der_asn1_dn identity");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), 
+            st->st_connection->this.id.der_asn1_dn.ptr, 
+            st->st_connection->this.id.der_asn1_dn.len);
+        } else {
+          ch.len = sizeof(st->st_connection->this.id.ip_addr) + 4;
+          ch.ptr = alloc_bytes(ch.len, "my identity (plaintext)");
+          ch.ptr[0] = (u_int8_t)st->st_connection->this.id.kind;
+          memset(&(ch.ptr[1]), 0, 1);
+          memset(&(ch.ptr[2]), 0, 2);
+          memcpy(&(ch.ptr[4]), &(st->st_connection->this.id.ip_addr), 
+            sizeof(st->st_connection->this.id.ip_addr));
+        }
+
+        /* PK encrypt this */
+        if (! pubkey_encrypt_chunk( &ch, st )) {
+          return STF_INTERNAL_ERROR;
+        }
+        if (!out_generic_chunk(ISAKMP_NEXT_NONCE, &isakmp_generic_desc,
+          &md->rbody, ch, "my identity (ciphertext)"))
+        return STF_INTERNAL_ERROR;
+        memset(ch.ptr, 0, ch.len);
+        freeanychunk(ch);
+
+        if (!build_and_ship_nonce_pk(st, &st->st_ni, &md->rbody,
+          ISAKMP_NEXT_NONE, "<Ni_b>PubKey_r"))
+          return STF_INTERNAL_ERROR;
+      } else {
+        DBG(DBG_PARSING,
+        DBG_log("Shipping nonce_i");
+        );
+        if (!build_and_ship_nonce(&st->st_ni, &md->rbody, 
+          ISAKMP_NEXT_NONE, "Ni"))
+          return STF_INTERNAL_ERROR;
+      }
+    }
+  }
+#endif
+
     /* finish message */
     close_message(&md->rbody);
 
@@ -1938,6 +2660,10 @@
 
     st->st_state = STATE_MAIN_I2;
 
+  DBG(DBG_PARSING,
+  DBG_log("finished main_inR1_outI2");
+  );
+
     return STF_REPLY;
 }
 
@@ -1957,6 +2683,10 @@
     struct state *const st = md->st;
     pb_stream *keyex_pbs = &md->chain[ISAKMP_NEXT_KE]->pbs;
 
+    DBG(DBG_PARSING,
+    DBG_log("in main_inI2_outR2");
+    );
+
     /* KE in */
     RETURN_STF_FAILURE(accept_KE(&st->st_gi, "Gi", st->st_oakley.group, keyex_pbs));
 
@@ -1986,8 +2716,9 @@
     compute_dh_shared(st, st->st_gi, st->st_oakley.group);
 #ifdef DODGE_DH_MISSING_ZERO_BUG
     if (st->st_shared.ptr[0] == 0)
-	return STF_DROP_DOOMED_EXCHANGE;
+      return STF_REPLACE_DOOMED_EXCHANGE;
 #endif
+
     if (!generate_skeyids_iv(st))
 	return STF_FAIL + AUTHENTICATION_FAILED;
     update_iv(st);
